package com.zhongzheng.modules.order.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.zhongzheng.modules.order.bo.OrderAddBo;
import com.zhongzheng.modules.order.bo.OrderBillSheetAddBo;
import com.zhongzheng.modules.order.bo.OrderBillSheetEditBo;
import com.zhongzheng.modules.order.bo.OrderBillSheetQueryBo;
import com.zhongzheng.modules.order.domain.OrderBillSheet;
import com.zhongzheng.modules.order.vo.OrderBillSheetVo;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 订单计费单Service接口
 *
 * @author hjl
 * @date 2021-11-09
 */
public interface IOrderBillSheetService extends IService<OrderBillSheet> {
	/**
	 * 查询单个
	 * @return
	 */
	OrderBillSheetVo queryById(Long sheetId);

	OrderBillSheetVo queryBySn(String sheetSn);

	/**
	 * 查询列表
	 */
	List<OrderBillSheetVo> queryList(OrderBillSheetQueryBo bo);

	/**
	 * 根据新增业务对象插入订单计费单
	 * @param bo 订单计费单新增业务对象
	 * @return
	 */
	Boolean insertByAddBo(OrderBillSheetAddBo bo);

	/**
	 * 根据编辑业务对象修改订单计费单
	 * @param bo 订单计费单编辑业务对象
	 * @return
	 */
	Boolean updateByEditBo(OrderBillSheetEditBo bo);

	/**
	 * 校验并删除数据
	 * @param ids 主键集合
	 * @param isValid 是否校验,true-删除前校验,false-不校验
	 * @return
	 */
	Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

	Map<String, Object> placeBillOrder(OrderBillSheetAddBo bo);
}
